## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

%global commit 236c8603b7883ddf6691f9a8f466f8e234c1ac61
%global snapdate 20220226

%global shortcommit %(echo '%{commit}' | cut -b -7)

Name:           geompp
Summary:        Basic geometrical utilities for C++
# Upstream has never chosen a version
Version:        0^%{snapdate}git%{shortcommit}
Release:        %autorelease -p

URL:            https://github.com/monocasual/geompp
Source0:        %{url}/archive/%{commit}/geompp-%{commit}.tar.gz
License:        GPLv3+

BuildRequires:  gcc-c++

# This package is header-only, so the binary RPMs do not include any compiled
# executables.
%global debug_package %{nil}

%global common_description %{expand:
%{summary}.}

%description %{common_description}


%package devel
Summary:        %{summary}

BuildArch:      noarch

# Header-only library
Provides:       geompp-static = %{version}-%{release}

%description devel %{common_description}


%prep
%autosetup -n geompp-%{commit}
# Patch to allow installing in a subdirectory of the global include path
# https://github.com/monocasual/geompp/issues/1
sed -r -i 's|^(#include ")([^/]+\.hpp")|\1geompp/\2|' src/*.hpp

# As a “smoke test”, create a source file that includes all of the API headers,
# and verify that we can compile and link it.
mkdir -p smoke_test
ln -s ../src/ smoke_test/geompp
cat > smoke_test/include_all.cpp <<EOF
$(find src -type f -name '*.hpp' -printf '#include "geompp/%%P"\n')
int main(int argc, char * argv[]) { (void) argc; (void) argv; return 0; }
EOF

%build
# No build section required for this header-only library

# “Smoke test” that verifies we can at least compile and link a source that
# includes the headers. There is no need to run the resulting executable, which
# does nothing.
%set_build_flags
mkdir -p '%{_vpath_builddir}/smoke_test'
${CXX} -Ismoke_test ${CPPFLAGS} ${LDFLAGS} \
    -o '%{_vpath_builddir}/smoke_test/include_all' \
    smoke_test/include_all.cpp


# Upstream has no tests, and our “smoke test” is satisfied by a successful
# %%build, so there is no %%check.


%install
install -t '%{buildroot}%{_includedir}/geompp' -D -m 0644 -p src/*.hpp


%files devel
%license LICENSE

%{_includedir}/geompp


%changelog
* Sat Feb 26 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0^20220226git236c860-0.1
- Update to 236c8603b7883ddf6691f9a8f466f8e234c1ac61

* Sat Feb 26 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0^20220226git4f6ee23-0.2
- Drop “forge” macros; put snapshot info in Version

* Tue Feb 01 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0-0.11
- Update to 4f6ee23809163c54b6b3722931eadf5de8b8d82b

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> 0-0.10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Dec 17 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0-0.9
- Allow the -devel package to be noarch

* Fri Nov 12 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0-0.8
- Add a compile-and-link “smoke test”

* Fri Nov 12 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0-0.7
- Simplify %%install section

* Fri Nov 12 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0-0.6
- Reduce macro indirection in the spec file

* Sun Sep 12 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0-0.5
- Update to 75e79f53b129a26859ae2644173f4d57954801fc

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> 0-0.4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Fri May 21 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.2.20210518git95ea180
- Fix internal includes to work with geompp/ include path

* Tue May 18 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.1.20210518git95ea180
- Initial package

